/**********************************************************************
 *<
	FILE: ABUF.H

	DESCRIPTION:

	CREATED BY: Dan Silva

	HISTORY:

 *>	Copyright (c) 1994, All Rights Reserved.
 **********************************************************************/

#ifndef __ABUF__H
#define __ABUF__H

// in ABTAB.C
extern short maskxsum[256];
extern unsigned char bitcount[256]; 
extern unsigned char bitmasks[18160]; 

/* XLine flags: */
#define LINE_FLIPX   1	  
#define LINE_FLIPY   2    
#define LINE_VERT    4    
#define LINE_REVD    8
#define LINE_REV_INOUT 16
#define LINE_HORIZ   32
#define LINE_SKIP   64

#define DO8X8

#ifdef DO4X4
#define NX 4
#define NY 4
#define NBRKS 8
#define NSLBITS 4  
#define NDBITS 5  
#define YFACTOR 1
#endif

#ifdef DO8X4
#define NX 8
#define NY 4
#define NBRKS 17
#define NSLBITS 5  
#define NDBITS 6  
#define YFACTOR 2
#endif

#ifdef DO8X8
#define NX 8
#define NY 8
#define NBRKS 36
#define NSLBITS 5  
#define NDBITS 7
#define YFACTOR 1
#endif

#define NPTS (NX*NY)
#define NBYTES (NPTS>>3)
#define SEQSIZE ((NPTS-1)*NBYTES)
#define BIT_MAP0 (SEQSIZE*NBRKS)
#define BIT_MAP1 (SEQSIZE*NBRKS+NBYTES)
#define NSLOPES (1<<NSLBITS) /* number of slopes in an octant */
#define NDISTS  (1<<NDBITS)  /* number of distances in a quadrant */
#define NDISTS2  (NDISTS>>1) 
#define NBITMASKS (SEQSIZE*NBRKS+NBYTES*2)
#define NMAPTAB (NSLOPES*NDISTS*2)
#define MASK_MAXY   (1<<NSLBITS)


#define AREA(m) mask_area((UBYTE *)m)
#define IS_ZERO(m)  ((((ULONG *)m)[0]==0)&&(((ULONG *)m)[1]==0))
#define IS_TOTAL(m)  ((((ULONG *)m)[0]==0xffffffff)&&(((ULONG *)m)[1]==0xffffffff))
#define IS_OPAQUE(ab) ((ab->flags&AB_TRANSPARENT)==0)
#define ALLONES (0xffffffff)
#define WTAREA(m) wtmask_area((UBYTE *)m)
#define LOGB2(x) (log(x)/.69314718)

#define COVERS(a,b)	((~a->mask[0]&b->mask[0])==0 &&(~a->mask[1]&b->mask[1])==0 )
#define OVERLAP(a,b) ((a->mask[0]&b->mask[0])!=0 || (a->mask[1]&b->mask[1])!=0 )

// Values return by ChkIntsct( )
#define NO_INTSCT 0
#define BACKWARDS 1
#define INTERSECT 2
#define COINCIDENT 3



#endif
