/**********************************************************************
 *<
	FILE: shadbuf.h : Shadow buffer renderer.

	DESCRIPTION:

	CREATED BY: Dan Silva

	HISTORY:

 *>	Copyright (c) 1994, All Rights Reserved.
 **********************************************************************/

#ifndef __SHADBUF__H
#define __SHADBUF__H


class ClipFlags;

//#define SHOWSHADMAP

class ShadBufRenderer {
	public:
		virtual int Render(
			RendContext &rc, 
			RenderGlobalContext *RGC, 
			float *buf,   // shadsize*shadsize  floats 
			BOOL parallel,
			int shadsize,
			float param,   	   // persp:field-of-view (radians) -- parallel : width in world coords
			float aspect,
			float clipDist,
			ObjLightDesc *ltDesc,
			Matrix3 worldToLight
			)=0;
		virtual	float Furthest()=0;
		virtual float Closest()=0;
		virtual void DeleteThis()=0;
	};

ShadBufRenderer *NewDefaultShadBufRenderer();

#endif __SHADBUF__H
